#include "stdafx.h"
#include "LottoMan.h"
#include "MainFrm.h"
#include "LottoManDoc.h"
#include "LottoManView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CLottoManApp* GetApp()
{
  return (CLottoManApp*) AfxGetApp();
}

BEGIN_MESSAGE_MAP(CLottoManApp, CWinApp)
	//{{AFX_MSG_MAP(CLottoManApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_COMMAND(ID_HELP, OnHelpIndex)
	ON_COMMAND(ID_HELP_SENDFEEDBACK, OnHelpSendfeedback)
	ON_COMMAND(ID_HELP_PRODUCTHOMEPAGE, OnHelpProducthomepage)
	ON_COMMAND(ID_HELP_AUTHORSHOMEPAGE, OnHelpAuthorshomepage)
	ON_COMMAND(ID_HELP_LOTTOHOMEPAGE, OnHelpLottohomepage)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

CLottoManApp::CLottoManApp()
{
}

CLottoManApp theApp;

BOOL CLottoManApp::InitInstance()
{
  //Usual MFC stuff
	Enable3dControls();

  //Initialise the MRU List
	LoadStdProfileSettings(4);

	// Register document templates
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CLottoManDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CLottoManView));
	AddDocTemplate(pDocTemplate);

  // enable file manager drag/drop and DDE Execute open
  EnableShellOpen();
  RegisterShellFileTypes();

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

void CLottoManApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CLottoManApp::OnHelpIndex() 
{
  //Form the path to the HTM file
  TCHAR sFilename[_MAX_PATH];
  TCHAR sDrive[_MAX_DRIVE];
  TCHAR sDir[_MAX_DIR];
  GetModuleFileName(NULL, sFilename, _MAX_PATH);
  _tsplitpath(sFilename, sDrive, sDir, NULL, NULL);
  _tmakepath(sFilename, sDrive, sDir, _T("LottoMan"), _T(".HTM"));

  HINSTANCE hHelp = ShellExecute(AfxGetMainWnd()->GetSafeHwnd(), _T("Open"), sFilename, NULL, NULL, SW_SHOW);
	if (hHelp <= (HINSTANCE) 32)
    AfxMessageBox(IDP_FAIL_SHOW_HELP);
}

void CLottoManApp::OnHelpSendfeedback() 
{
  HINSTANCE hHelp = ShellExecute(AfxGetMainWnd()->GetSafeHwnd(), _T("Open"), _T("mailto:pjna@naughter.com"), NULL, NULL, SW_SHOW);
	if (hHelp <= (HINSTANCE) 32)
    AfxMessageBox(IDP_FAIL_SEND_FEEDBACK);
}

void CLottoManApp::OnHelpProducthomepage() 
{
  HINSTANCE hHelp = ShellExecute(AfxGetMainWnd()->GetSafeHwnd(), _T("Open"), _T("http://www.naughter.com/lottoman.html"), NULL, NULL, SW_SHOW);
	if (hHelp <= (HINSTANCE) 32)
    AfxMessageBox(IDP_FAIL_CONNECT_WEB);
}

void CLottoManApp::OnHelpAuthorshomepage() 
{
  HINSTANCE hHelp = ShellExecute(AfxGetMainWnd()->GetSafeHwnd(), _T("Open"), _T("http://www.naughter.com"), NULL, NULL, SW_SHOW);
	if (hHelp <= (HINSTANCE) 32)
    AfxMessageBox(IDP_FAIL_CONNECT_WEB);
}

void CLottoManApp::OnHelpLottohomepage() 
{
  HINSTANCE hHelp = ShellExecute(AfxGetMainWnd()->GetSafeHwnd(), _T("Open"), _T("http://www.lotto.ie"), NULL, NULL, SW_SHOW);
	if (hHelp <= (HINSTANCE) 32)
    AfxMessageBox(IDP_FAIL_CONNECT_WEB);
}



CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
