#ifndef __LOTTOMANDOC_H__
#define __LOTTOMANDOC_H__


class CMember : public CObject
{
public:
//Constructors / Destructors
 CMember();
 CMember(const CMember& member);
 ~CMember();

//Methods
 CMember& operator=(const CMember& member);
 virtual void Serialize(CArchive& ar);

//Data (just left public for simplicity reasons)
	CString          m_sName;
  CArray<int, int> m_Numbers;
  BOOL             m_bEnabled;

	//Non-Persistant
	BOOL m_bMarkedForDeletion;
};


class CLottoManDoc : public CDocument
{
protected: // create from serialization only
	CLottoManDoc();
	DECLARE_DYNCREATE(CLottoManDoc)

	//{{AFX_VIRTUAL(CLottoManDoc)
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

public:
	virtual ~CLottoManDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

//Methods
  void     MarkMemberAsDeleted(int nIndex);
  int      NumberOfMembers() const;
  CString  CreateUniqueMemberName() const;
  BOOL     DoesMemberNameExist(const CString& sName, int nExistingIndex) const;
  CMember* GetAtMember(int nMemberNum) const;

//Serialized member variables
  CArray<CMember*, CMember*&> m_Members;            //All of the members
  int                         m_nListViewStyle;     //The preferred UI listview style
  int                         m_nMaxLottoNumber;    //The maximum number that is allowed in the lotto (e.g. the standard Irish Lotto uses 42)
  int                         m_nNumbersInDraw;     //The numbers picked in the draw (e.g. the Irish Lotto uses 6 numbers)
  BOOL                        m_bBonusNumberPicked; //Is a bonus number picked in the draw (e.g. the Irish Lotto does use a bonus number)

protected:
  void FreeAllMemory();

	//{{AFX_MSG(CLottoManDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__LOTTOMANDOC_H__