#ifndef __LOTTOMANVIEW_H__
#define __LOTTOMANVIEW_H__

#include "LottoManDoc.h"

class CLottoManView : public CListView
{
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	CLottoManDoc* GetDocument();


protected:
	CLottoManView();
	DECLARE_DYNCREATE(CLottoManView)

	//{{AFX_VIRTUAL(CLottoManView)
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CLottoManView)
	afx_msg void OnEditSelectall();
	afx_msg void OnEditInvertselection();
	afx_msg void OnFileDelete();
	afx_msg void OnUpdateFileDelete(CCmdUI* pCmdUI);
	afx_msg void OnReturn(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFileOpenItem();
	afx_msg void OnUpdateFileOpenItem(CCmdUI* pCmdUI);
	afx_msg void OnFileRename();
	afx_msg void OnUpdateFileRename(CCmdUI* pCmdUI);
	afx_msg void OnFileProperties();
	afx_msg void OnUpdateFileProperties(CCmdUI* pCmdUI);
	afx_msg void OnFileCheckResults();
	afx_msg void OnUpdateFileCheckResults(CCmdUI* pCmdUI);
	afx_msg void OnViewDetails();
	afx_msg void OnUpdateViewDetails(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewLargeIcon(CCmdUI* pCmdUI);
	afx_msg void OnViewLargeIcon();
	afx_msg void OnViewList();
	afx_msg void OnUpdateViewList(CCmdUI* pCmdUI);
	afx_msg void OnViewSmallIcon();
	afx_msg void OnUpdateViewSmallIcon(CCmdUI* pCmdUI);
	afx_msg void OnDeleteitem(NMHDR* pNMHDR, LRESULT* pResult);
  afx_msg void OnContextMenu(CWnd*, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

  void ShowRememberedColumnWidth(const CString& sEntry);
  void StoreColumnWidth(const CString& sEntry);
  void ChangeStyle(LONG nNewStyle);
  BOOL IsSelected(int nIndex) const;
  BOOL IsAnythingSelected() const;
  int  GetCurSel() const;
  void SetSelected(int nIndex, BOOL bSelect) const;
  LONG GetStyle();
  BOOL IsWizardSelected();
  BOOL IsSettingsSelected();
  BOOL IsItemWizard(int nIndex) const;
  BOOL IsItemSettings(int nIndex) const;
  int NumberNonWizardSelectedItems() const;
  int GetImageItemData(int nIndex) const;
  int GetMemberArrayIndex(int nIndex);
  CMember* GetMember(int nIndex);
  void AddMemberToView(int nNumbersInDraw, CMember* pMember, int nMemberIndex);
  void UpdateMemberToView(int nNumbersInDraw, CMember* pMember, int nIndex);

  CImageList m_ILSmall;
  CImageList m_ILBig;
  BOOL m_bInPlaceEditing;
};

#ifndef _DEBUG  // debug version in LottoManView.cpp
inline CLottoManDoc* CLottoManView::GetDocument()
   { return (CLottoManDoc*)m_pDocument; }
#endif

#endif //__LOTTOMANVIEW_H__