#include "stdafx.h"
#include "LottoMan.h"
#include "MainFrm.h"
#include "LottoManView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
  ON_UPDATE_COMMAND_UI(ID_INDICATOR_MEMBERS, OnUpdateMembers)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,
  ID_INDICATOR_MEMBERS,
};

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |	CBRS_TOOLTIPS | CBRS_FLYBY);

  return 0;
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
#endif //_DEBUG

void CMainFrame::OnUpdateMembers(CCmdUI* pCmdUI)
{
  CLottoManView* pView = (CLottoManView*) GetActiveView();
  if (pView)
  {
    ASSERT(pView->IsKindOf(RUNTIME_CLASS(CLottoManView)));
    CLottoManDoc* pDoc = pView->GetDocument();
    CString sNumber;
    sNumber.Format(_T("%d"), pDoc->NumberOfMembers());
    CString sText;
    AfxFormatString1(sText, IDS_INDICATOR_MEMBERS, sNumber);
    m_wndStatusBar.SetPaneText(m_wndStatusBar.CommandToIndex(ID_INDICATOR_MEMBERS), sText);
    pCmdUI->Enable(TRUE);
  }
}
