#include "stdafx.h"
#include "LottoMan.h"
#include "MemberUI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CMemberPage1, CPropertyPage)

CMemberPage1::CMemberPage1() : CPropertyPage(CMemberPage1::IDD)
{
	//{{AFX_DATA_INIT(CMemberPage1)
	m_sName = _T("");
	m_bEnabled = FALSE;
	//}}AFX_DATA_INIT
	m_nNum1 = -1;
	m_nNum2 = -2;
	m_nNum3 = -3;
	m_nNum4 = -4;
	m_nNum5 = -5;
	m_nNum6 = -6;
  m_bEnabled = TRUE;
	m_nMemberIndex = -1;
  m_pDoc = NULL;
}

CMemberPage1::~CMemberPage1()
{
}

void CMemberPage1::DoDataExchange(CDataExchange* pDX)
{
  ASSERT(m_pDoc);

	CPropertyPage::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CMemberPage1)
	DDX_Control(pDX, IDC_NAME, m_ctrlName);
	DDX_Text(pDX, IDC_NAME, m_sName);
	DDX_Check(pDX, IDC_ENABLED, m_bEnabled);
	//}}AFX_DATA_MAP

  int nTotalNumbersDrawn = m_pDoc->m_nNumbersInDraw;

	DDX_Text(pDX, IDC_NUM1, m_nNum1);
	DDV_MinMaxInt(pDX, m_nNum1, 1, m_pDoc->m_nMaxLottoNumber);

  if (nTotalNumbersDrawn > 1)
  {
	  DDX_Text(pDX, IDC_NUM2, m_nNum2);
	  DDV_MinMaxInt(pDX, m_nNum2, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 2)
  {
	  DDX_Text(pDX, IDC_NUM3, m_nNum3);
	  DDV_MinMaxInt(pDX, m_nNum3, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 3)
  {
	  DDX_Text(pDX, IDC_NUM4, m_nNum4);
	  DDV_MinMaxInt(pDX, m_nNum4, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 4)
  {
	  DDX_Text(pDX, IDC_NUM5, m_nNum5);
	  DDV_MinMaxInt(pDX, m_nNum5, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 5)
  {
	  DDX_Text(pDX, IDC_NUM6, m_nNum6);
	  DDV_MinMaxInt(pDX, m_nNum6, 1, m_pDoc->m_nMaxLottoNumber);
  }

	if (pDX->m_bSaveAndValidate)
	{
		if (m_sName.GetLength() == 0)
		{
			AfxMessageBox(IDP_NEED_NONEMPTY_STRING);
			pDX->PrepareEditCtrl(IDC_NAME);
			pDX->Fail();
		}
		else if (m_pDoc->DoesMemberNameExist(m_sName, m_nMemberIndex))
		{
			AfxMessageBox(IDP_RENAME_UNIQUE_MEMBERNAME);
			pDX->PrepareEditCtrl(IDC_NAME);
			pDX->Fail();
		}

    //Check all numbers are unique
    BOOL bIsUnique = (m_nNum1 != m_nNum2);
    if (nTotalNumbersDrawn > 2)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum3);
    if (nTotalNumbersDrawn > 3)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum4);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum6);
    if (nTotalNumbersDrawn > 2)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum3);
    if (nTotalNumbersDrawn > 3)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum4);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum6);
    if (nTotalNumbersDrawn > 3)
      bIsUnique = bIsUnique && (m_nNum3 != m_nNum4);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum3 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum3 != m_nNum6);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum4 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum4 != m_nNum6);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum5 != m_nNum6);
    if (!bIsUnique)
		{
			AfxMessageBox(IDP_NEED_UNIQUE_NUMBERS);
			pDX->PrepareEditCtrl(IDC_NUM1);
			pDX->Fail();
		}
	}
}

BEGIN_MESSAGE_MAP(CMemberPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CMemberPage1)
	ON_EN_CHANGE(IDC_NAME, OnChangeName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CMemberPage1::OnChangeName() 
{
	CString sName;
	GetDlgItemText(IDC_NAME, sName);
	CString sCaption;
	AfxFormatString1(sCaption, IDS_PROPERTIES_FOR, sName);
	GetParent()->SetWindowText(sCaption);
}

BOOL CMemberPage1::OnInitDialog() 
{
  //Validate our parameters
  ASSERT(m_pDoc);

  //Let the base class do its thing
	CPropertyPage::OnInitDialog();

  //Enable / Disable the relavent controls
  int nTotalNumbersDrawn = m_pDoc->m_nNumbersInDraw;
  if (nTotalNumbersDrawn < 2)
  {
    GetDlgItem(IDC_PROMPT_NUM2)->EnableWindow(FALSE);
    GetDlgItem(IDC_NUM2)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 3)
  {
    GetDlgItem(IDC_PROMPT_NUM3)->EnableWindow(FALSE);
    GetDlgItem(IDC_NUM3)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 4)
  {
    GetDlgItem(IDC_PROMPT_NUM4)->EnableWindow(FALSE);
    GetDlgItem(IDC_NUM4)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 5)
  {
    GetDlgItem(IDC_PROMPT_NUM5)->EnableWindow(FALSE);
    GetDlgItem(IDC_NUM5)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 6)
  {
    GetDlgItem(IDC_PROMPT_NUM6)->EnableWindow(FALSE);
    GetDlgItem(IDC_NUM6)->EnableWindow(FALSE);
  }

	return TRUE;
}










IMPLEMENT_DYNAMIC(CMemberPropertySheet, CPropertySheet)

CMemberPropertySheet::CMemberPropertySheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_page1);
}

CMemberPropertySheet::CMemberPropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_page1);
}

CMemberPropertySheet::~CMemberPropertySheet()
{
}

BEGIN_MESSAGE_MAP(CMemberPropertySheet, CPropertySheet)
	//{{AFX_MSG_MAP(CMemberPropertySheet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CMember CMemberPropertySheet::GetMember() const
{
  CMember member;
  member.m_Numbers.SetSize(6);

	member.m_sName = m_page1.m_sName;
  member.m_Numbers.SetAt(0, m_page1.m_nNum1);
  member.m_Numbers.SetAt(1, m_page1.m_nNum2);
  member.m_Numbers.SetAt(2, m_page1.m_nNum3);
  member.m_Numbers.SetAt(3, m_page1.m_nNum4);
  member.m_Numbers.SetAt(4, m_page1.m_nNum5);
  member.m_Numbers.SetAt(5, m_page1.m_nNum6);
  member.m_bEnabled =    m_page1.m_bEnabled;

  return member;
}

void CMemberPropertySheet::SetMember(const CMember& member)
{
	m_page1.m_sName = member.m_sName;
  m_page1.m_nNum1 = member.m_Numbers.GetAt(0);
  m_page1.m_nNum2 = member.m_Numbers.GetAt(1);
  m_page1.m_nNum3 = member.m_Numbers.GetAt(2);
  m_page1.m_nNum4 = member.m_Numbers.GetAt(3);
  m_page1.m_nNum5 = member.m_Numbers.GetAt(4);
  m_page1.m_nNum6 = member.m_Numbers.GetAt(5);
  m_page1.m_bEnabled = member.m_bEnabled;
}




